Package org.apache.sling.feature.extension.apiregions.api.config

# Class FactoryConfigurationDescription

java.lang.Object
org.apache.sling.feature.extension.apiregions.api.config.AttributeableEntity
org.apache.sling.feature.extension.apiregions.api.config.DescribableEntity
org.apache.sling.feature.extension.apiregions.api.config.ConfigurableEntity
org.apache.sling.feature.extension.apiregions.api.config.FactoryConfigurationDescription

public class FactoryConfigurationDescription extends ConfigurableEntity
Description of an OSGi factory configuration This class is not thread safe.

## Constructor Summary

Constructors
Constructor
Description
`FactoryConfigurationDescription()`

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Clear the object and set the defaults
`protected jakarta.json.JsonObjectBuilder`
`createJson()`
Convert this object into JSON
`void`
`fromJSONObject(jakarta.json.JsonObject jsonObj)`
Extract the metadata from the JSON object.
`Mode`
`getInternalMode()`
Get the internal mode
`List<String>`
`getInternalNames()`
Get the internal factory configuration name
`Set<Operation>`
`getOperations()`
Get the operations
`protected void`
`setDefaults()`
Apply the non-null default values.
`void`
`setInternalMode(Mode internalMode)`
Set the internal mode

### Methods inherited from class org.apache.sling.feature.extension.apiregions.api.config.ConfigurableEntity

`getInternalPropertyNames, getMode, getPropertyDescriptions, getRegion, isAllowAdditionalProperties, setAllowAdditionalProperties, setMode, setRegion`

### Methods inherited from class org.apache.sling.feature.extension.apiregions.api.config.DescribableEntity

`getDeprecated, getDescription, getEnforceOn, getSince, getTitle, setDeprecated, setDescription, setEnforceOn, setSince, setTitle`

### Methods inherited from class org.apache.sling.feature.extension.apiregions.api.config.AttributeableEntity

`getAttributes, getBoolean, getInteger, getNumber, getString, getString, getStringArray, setString, setStringArray, toJSONObject`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### FactoryConfigurationDescription

public FactoryConfigurationDescription()

## Method Details

### setDefaults

protected void setDefaults()
Description copied from class: `AttributeableEntity`
Apply the non-null default values.

Overrides:
  `setDefaults` in class `ConfigurableEntity`

### clear

public void clear()
Clear the object and set the defaults

Overrides:
  `clear` in class `ConfigurableEntity`

### fromJSONObject

public void fromJSONObject(jakarta.json.JsonObject jsonObj) throws IOException
Extract the metadata from the JSON object. This method first calls `clear()`

Overrides:
  `fromJSONObject` in class `ConfigurableEntity`
Parameters:
  `jsonObj` - The JSON Object
Throws:
  `IOException` - If JSON parsing fails

### getOperations

public Set<Operation> getOperations()
Get the operations

Returns:
  Mutable set of operations

### getInternalNames

public List<String> getInternalNames()
Get the internal factory configuration name

Returns:
  Mutable list of internal names

### getInternalMode

public Mode getInternalMode()
Get the internal mode

Returns:
  The internal mode

### setInternalMode

public void setInternalMode(Mode internalMode)
Set the internal mode

Parameters:
  `internalMode` - The internal mode

### createJson

protected jakarta.json.JsonObjectBuilder createJson() throws IOException
Convert this object into JSON

Overrides:
  `createJson` in class `ConfigurableEntity`
Returns:
  The json object builder
Throws:
  `IOException` - If generating the JSON fails